/*
   ----------------------------------------------------------------------------
	ADODUser.prg
   A sample dBL program from 
   The dBASE Book Plus by Kenneth J. Mayer. 
   Program copyright 2015. 
   Permission is granted for use as a learning tool for dBASE Plus.
   Sample from: Chapter 4
	
   This is the way to programmatically add a user ...
	----------------------------------------------------------------------------
*/

clear
try

	d = new ADODatabase()
	d.databaseName := "BookSample_ADO"
	d.loginString  := "SYSDBA/masterkey"
	d.active       := true

   // using the database objects' executeSQL method:
   d.executeSQL( [create user TestUser2 password 'User123' Firstname 'Fred' Middlename 'J' Lastname 'User'])
	? "User TestUser2 created"

catch( ADOException e )
   
	// the error object itself:
	? "Code:     "+e.code
	? "Filename: "+e.filename
	? "LineNo:   "+e.lineNo
	? "Message:  "+e.message

   local aError, i
	aError = e.errors
	//? "Error array size: "+aError.size

	for i = 1 to aError.size
	   ? // blank line
	   ? "message:    "+ aError[i].message
      ? "code:       "+ aError[i].code
		? "source:     "+ aError[i].source
      ? "nativeCode: "+ aError[i].nativeCode
      ? "sqlCode:    "+ aError[i].sqlCode
   next
		
	return
endtry

d.active := false
release object d
d := null