/*
   ----------------------------------------------------------------------------
	TestAddRow.prg
   A sample dBL program from 
   The dBASE Book Plus by Kenneth J. Mayer. 
   Program copyright 2015. 
   Permission is granted for use as a learning tool for dBASE Plus.
   Sample from: Chapter 4
	
   This program was put together with the sole purpose of testing the 
	method addRow in the datamodule used in the sample code. It is here as
	a separate program to show how this works.
	----------------------------------------------------------------------------
*/
clear

aMyData = new array(1,2)
aMyData[1,1] = "InvoiceNumber"
aMyData[1,2] = GetNextKey( "InvNum_Seq" )
aMyData.grow(1)
aMyData[2,1] = "InvoiceDate"
aMyData[2,2] = date()
aMyData.grow(1)
aMyData[3,1] = "CustomerNumber"
aMyData[3,2] = 3

set procedure to DataLayer.dmd
oDMD = new DataLayerDataModule()
oDMD.addRow( "Invoices", aMyData )
? "New Row Added"
release object oDMD
oDMD := null
close procedure DataLayer.dmd

function GetNextKey( cGenName )
   /*
	   Function to generate next key value
		for a Firebird Sequence (created by
		Mervyn Bick)
	*/
   private dGen, qGen, nVal, cCmd
	dGen = new ADODatabase()
	dGen.databaseName := "BookSample_ADO_RO"
	dGen.loginString  := "SYSDBA/masterkey"
	dGen.active       := true
	
	qGen = new ADOQuery()
	qGen.database    := dGen
	cCmd = "Select Gen_ID("+cGenName+",1) from MyGen" 
	qGen.sql          = cCmd
	qGen.requestLive := false
	qGen.active      := true
	qGen.rowset.first()
	
	// next key value:
	nVal = qGen.rowset.fields[1].value 
	
   // deactivate:	
	qGen.active := false
	dGen.active := false
return nVal