// file -- OLEMAPI.CC

/* ---------------------------------------------------------------- 
    OLEMAPI -- by Bowen Moursund -- is a custom class to send
    text to an email address.

    Assumes that Microsoft's Mapi OLE2 classes are properly
    registered.

    Methods:
       Logon -- needed to logon to the "profile"
       Logoff -- logs off the MAPI connection
       QwikMsg -- actually sends the message
         parameters: cName -- username you are sending
                              the message to
                     cSubject -- subject for message
                     cText -- text of message
                     lMsgDlg -- ??
       Release -- log off if needed and release class from memory

    For further details, contact the author ...
----------------------------------------------------------------  */
CLASS OLEMAPI(cProfile)

   this.Profile = cProfile
   this.LoggedOn = false

   this.MapiObj = new OLEAutoclient("MAPI.Session")
   this.MapiObj = new OLEAutoclient("MAPI.Session")

   function logon
      if type("this.Profile") == "C"
         this.MapiObj.logon(this.Profile)
      else
         this.MapiObj.logon()
      endif

   function logoff
       this.MapiObj.logoff()

   function QwikMsg(cName, cSubject, cText, lMsgDlg)
      local oMsg, oRecip
      this.logon()
      oMsg = this.MapiObj.outbox.messages.add()
      oMsg.Text = cText
      oMsg.Subject = cSubject
      oRecip = oMsg.Recipients.add()
      oRecip.Name = cName
      oRecip.resolve()
      oMsg.update()
      oMsg.send(0, iif(lMsgDlg,1,0))
      this.logoff()

   function release
      if this.LoggedOn
         this.MapiObj.logoff()
      endif
      release object this

ENDCLASS

/*
    End of file: OLEMAPI.CC
*/