/*
    -----------------------------------------------------------
    custbuttSpanish.h
    February 3, 1999
    Ken Mayer
    Italian Translation of "custButtEnglish.h" 
       by Francesco Navarria

     *** Note: you should copy this file to your
     ..\Visual dBASE\INCLUDE directory for it to
     be used properly by all of your applications.

    This is an 'include' file with the speedTips and
    message box text for each of the buttons in CUSTBUTT.CC.
    The idea is that by defining them here, someone using
    another language can copy this file and translate the
    text in the .H file, and the only change necessary in
    CUSTBUTT.CC is the #INCLUDE statement to include
    the correct file.

    When translating, make sure you do NOT change the names
    of the constants ...

    *****************
    November 11, 2000
    *****************
    NOTE: If you update your application to use the 
    CUSTBUTT.CC file from dUFLP version 2KC (DUFLP2KC.EXE),
    then you MUST update your .H file -- this is a fix based
    on a discovery that EMPTYTABLE and FILTER strings could
    cause problem in code that used the database object
    emptyTable method, or the rowset object's filter property.
    These strings are defined as EMPTYTABLETEXT and FILTERTEXT
    now, and will not cause a conflict.

    Suggestion by Jos Luis Prez Diez ...
    **********************************************************
    *** WARNING: If you are not using an ANSI language driver
    *** for your tables (at the Command window: ? LDRIVER()
    *** it should be obvkous) or have the setting:
    ***  LDRIVER=WINDOWS in your VDB.INI file (under the
    *** [CommandSettings] heading) do NOT attempt save
    *** this file ... you can wipe out the upper ANSI characters
    *** used. 
    **********************************************************
    -----------------------------------------------------------
*/

// ----------------------------------------------------------
// navigation buttons:
                                //"First row in rowset"
#define TOPTIP                  "Primera fila"
                                //"Previous row in rowset"
#define PREVTIP                 " Fila anterior"
                                 //"Next row in rowset"
#define NEXTTIP                 "Fila  siguiente"
                                //"Last row in rowset"
#define ENDTIP                  "Ultima fila"

// ----------------------------------------------------------
// editing buttons:
                                //"Add new row"
#define ADDTIP                  "Aadir fila nueva"
                                //"Copy data to a new Row"
#define CARRYTIP                "Copiar datos en una nueva fila"
                                //"Edit current row"
#define EDITTIP                 "Editar la fila actual"
                                //"Save current row"
#define SAVETIP                 "Guardar la fila actual"
                                //"Delete current row"
#define DELETETIP               "Borrar la fila actual"
                                //"Abandon changes to row"
#define ABANDONTIP              "Descartar cambios en la fila actual"
// ----------------------------------------------------------
// filter/locate buttons:
                                //"Filter/Run/Clear Filter"
#define FILTERTIP               "Filtra/Activa/Desactiva el filtro"
                                //"Locate/Run/Clear Locate"
#define LOCATETIP               "Encuentra/Activa/Desactiva Encuentra"

// ----------------------------------------------------------
// clipboard buttons:
                                //"Cut selected text"
#define CUTTIP                  "Cortar la seleccin"
                                //"Copy selected text"
#define COPYTIP                 "Copiar la seleccon"
                                //"Paste from clipboard"
#define PASTETTIP               "Pegar desde el portapapeles"

// ----------------------------------------------------------
// misc. buttons:
                                //"Close this form"
#define CLOSETIP                "Cerrar"
                                //"Yes"
#define YESTIP                  "Si"
                                //"No"
#define NOTIP                   "No"
                                //"Cancel"
#define CANCELTIP               "Cancela"
                                //"Question? Help?"
#define QUESTIONTIP             "Pregunta?, Ayuda?"
                                //"Run"
#define RUNTIP                  "Ejecuta"
                                //"Information"
#define INFOTIP                 "Informacin"
                                //"Restore from disk"
#define RESTOREFROMDISKTIP      "Recupera del disco"
                                //"Save to disk"
#define SAVETODISKTIP           "Guardar en disco"
                                //"Open file ..."
#define OPENFILETIP             "Abrir archivo ..."
                                //"Tool Button"
#define TOOLBUTTONTIP           "Boton de herramientas"
                                //"Print"
#define PRINTTIP                "imprime"
                                //"Search"
#define SEARCHTIP               "Busca"
                                //"Continue search"
#define SEARCHAGAINTIP          "Continuar buscando"
                                //"Replace"
#define REPLACETIP              "Sustituir"
                               //"Exit"
#define EXITTIP                 "Salir"
                                //"First Page"
#define FIRSTPAGETIP            "Primera Pagina"
                                //"Next Page"
#define NEXTPAGETIP             "Pagina Siguiente"
                                //"Previous Page"
#define PREVIOUSPAGETIP         "Pagina Anterior"
                                //"The Light Goes Off"
#define LIGHTBULBTIP            "Se Apaga La Luz"


// ----------------------------------------------------------
// strings used in dialog boxes in CUSTBUTT.CC
// ----------------------------------------------------------

// This one appears as the title for various dialogs
                                //"Can't do it!"
#define CANTDOIT                "No puedo hacelo!"

// ----------------------------------------------------------
// One of these appears anytime we check to see if the rowset
// is null, and is the text in the messagebox
                                //"Cannot Navigate with no rowset!"
#define NAVNOROWSET             "Sin rowset no hay navegacin!"
                                //"Cannot add rows with no rowset!"
#define ADDNOROWSET             "Sin rowset no hay donde aadir"
                                //"Cannot copy rows on a form without a rowset!"
#define COPYNOROWSET            "Sin rowset no hay filas a copiar!"
                                //"Cannot update rows on a form without a rowset!"
#define EDITNOROWSET            "Sin rowset no hay filas a actualizar!"
                                //"Cannot save changes to rows on a form without a rowset!"
#define SAVENOROWSET            "Sin rowset no hay filas donde guardar los cambios!"
                                //"Cannot save delete rows on a form without a rowset!"
#define DELETENOROWSET          "Sin rowset no hay filas que borrar!"
                                //"Cannot abandon changes to rows on a form without a rowset!"
#define ABANDONNOROWSET         "Sin rowset no hay filas en que abandonar cambios!"
                                //"Cannot filter an empty or missing rowset!"
#define FILTERNOROWSET          "No se puede filtrar un rowset vaco o nulo!"
                                //"Cannot perform a locate with no rowset!"
#define LOCATENOROWSET          "Sin rowset no hay filas a encontrar!"

// ----------------------------------------------------------
// this is the title and message when the user attempts
// to navigate or close a form and the data has
// changed ...
                                //"Data has changed"
#define DATACHANGED             "Los datos han cambiado"
                                //"Save changes before leaving record?"
#define SAVECHANGES             "Guardar los cambios antes de dejar este registro?"

// ----------------------------------------------------------
// Title when user can't navigate:
                                //"Can't Navigate!"
#define CANTNAVIGATE            "Navegacion imposible!"

// ----------------------------------------------------------
// Other messages ...
                                //"You are in filter mode"
#define INFILTERMODE            "Modo filtro"
                                //"You are in locate mode"
#define INLOCATEMODE            "Modo Encontrar"
                                //"At first row in rowset"
#define ATFIRSTROW              "Primera fila del rowset"
                                //"At last row in rowset"
#define ATLASTROW               "Ultima fila del rowset"
                                //"Row is copied -- you are in append mode. Make changes and save or abandon new row."
#define ROWISCOPIED             "Fila copiada - Estas aadiendo. Cambia y guarda o abandona la nueva fila."

#define ROWLOCKED               "Row is being edited by another. Try again later."
                                //"Cannot Save edits/new row when you weren't editing/adding"
#define NOTEDITING              "No se guardan los cambios si no se esta editando o aadiendo"
                                //"Key Violation - That Key already exists."
#define KEYVIOLATION            "Error en la clave - Esta Clave existe."
                                //"Unknown error -- "
#define UNKNOWNERROR            "Error  desconocido-- "
                                //"You are about to delete the current row." + CHR(13) + "Click Yes to delete the current row."
#define DELETEYESNO             "Se Borrara la fila actual." + CHR(13) + "Pulsar en Si para borrarla."
                                //"Nothing to delete!"
#define NOTHINGTODELETE         "Nada que borrar!"
                                //"Abandoning the row will cancel the filter!"
#define ABANDONWILLCANCELFILTER "Si abandonas la fila cancelaras el filtro!"
                                //"Abandoning the row will cancel the locate!"
#define ABANDONWILLCANCELLOCATE "Si abandonas la fila cancelaras la posicion!"
                                //"Cannot Abandon edits/new row when you weren't editing/adding!"
#define NOTHINGTOABANDON        "No se puede abandonar los cambios si no se esta editando o aadiendo!"
                                //"No Match"
#define NOMATCH                 "No hay coincidencias"
                                //"Exit from filter mode!"
#define EXITFROMFILTER          "Salir de modo filtr!"
                                //"No more matches!"
#define NOMOREMATCHES           "No hay ms coincidencias!"
                                //"Can't search in memo field!"
#define CANTSEARCHINMEMO        "No se puede buscar en campo memo!"
                                //"Can't filter on a memo field!"
#define CANTFILTERINMEMO        "No se puede filtrar por campo memo!"

// ------------------------------------------------------------
// Misc Titles
                                //"Can't Add a new row!"
#define CANTADDROW              "No se pueden aadir filas!"
                                //"Can't Copy row!"
#define CANTCOPYROW             "No puedo copiar la fila!"
                                //"Copy complete"
#define COPYCOMPLETE            "Copia completa"
                                //"Can't Edit row!"
#define CANTEDITROW             "No se puede editar la fila!"
                                //"Can't Save row!"
#define CANTSAVEROW             "Non se puede guardar la fila!"
                                //"No changes to save!"
#define NOCHANGES               "No hay cambios que guardar!"
                                //"Can't Delete row!"
#define CANTDELETEROW           "No se puede Borrar la fila!"
                                //"Alert"
#define ALERT                   "Alerta"
                                //"Empty table"
#define EMPTYTABLETEXT          "Tabla vacia"
                                //"Cancel Filter?"
#define CANCELFILTER            "Cancelar el Filtro?"
                                //"Cancel Locate?"
#define CANCELLOCATE            "Cancelar el Encontrar?"
                                //"Can't abandon row!"
#define CANTABANDONROW          "No se puede abandonar la fila!"
                                //"Can't set a filter!"
#define CANTSETFILTER           "No se puede establecer un filtro!"
                                //"Filter"
#define FILTERTEXT              "Filtro"
                                //"Can't start a search!"
#define CANTSEARCH              "No se puede comenzar la busqueda!"
                                //"Search"
#define SEARCH                  "Busqeda"

// -----------------------------------------------------------
// kmRowState -- states:
//"Closed"
#define STATECLOSED             "Cerrada"
                                //"View" // or "Browse"
#define STATEVIEW               "Vista" // or "Browse"
                                //"Edit"
#define STATEEDIT               "Editando"
                                //"Append"
#define STATEAPPEND             "Aadiendo"
                                //"Filter"
#define STATEFILTER             "Filtrando"
                                //"Locate"
#define STATELOCATE             "Encontrando"

// -----------------------------------------------------------
// End of header file: custButtSpanish.h
// -----------------------------------------------------------

