/*
   ShowArray2.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 21
   Display the contents of an array of any number of columns. 
*/

// Program: ShowArray2.prg
parameter oArray
if type( "oArray" ) # "A"
   ? "Not an array!"
   return
endif

nRows    = oArray.subscript( oArray.size, 1)
nColumns = oArray.subscript( oArray.size, 2)
// display column headers
for nColumn = 1 to nColumns
    // assumes that each column will contain < 25 characters
    ?? "Column "+nColumn at (20*(nColumn-1))+7
next

// display items in each row for each column
for nRow = 1 to nRows
    // row header
    ? "Row "+nRow
    for nColumn = 1 to nColumns
        // actual element to be displayed
        ?? oArray[nRow,nColumn]  at (20*(nColumn-1))+7
    next
next

