/*
   ExcelExportTest.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 22
   Export some data to an Excel Spreadsheet
*/

// instantiate Excel object
oExcel = new oleAutoclient("excel.application")
// create new workbook
oWorkBook = oExcel.workbooks.add()

dData = new database()
dData.databaseName := "DBASESAMPLES"
dData.active       := true
qFish = new query()
qFish.database := dData
qFish.sql      := "select * from fish" 
qFish.active   := true
qFish.rowset.indexName := "Name"
qFish.rowset.first()

// Loop through the rows of the table:
nRows = 0
do while not qFish.rowset.endOfSet
   nRows++ // increment row counter
   // Loop through the fields (columns) of the table, 
   // but not the image field which is the last one:
   for nCols = 1 to qFish.rowset.fields.size - 1
       // get the value:
       xValue = qFish.rowset.fields[ nCols ].value
       // get the new cell to add data to:
       oCell = oExcel.ActiveSheet.cells( nRows, nCols )
       // assign value to the cell:
       oCell.formula = xValue 
       // from Gary White's Xldef.h --
       // set the vertical alignment to the top:
       oCell.verticalAlignment := -4160
   next // field

   // Next row:
   qFish.rowset.next()
enddo

// size the columns to fit
oExcel.ActiveSheet.Columns.AutoFit()

// save to disk
oWorkBook.SaveAs(set("dire")+"\TestExcelExport.xls")
// show the result
oExcel.visible = true

// cleanup:
oExcel = null
qFish.active := false
release object qFish
dData.active := false
release object dData
