/*
   AutoIncFields.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2012. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 25
   This small program shows how to use the code from qBDEMgr.cc
   provided by dBASE to retrieve and/or change the value 
   in a level 7 dBASE table's autoIncrement field (if any).
*/

clear

close database // make sure we do this in the current folder

// for this to work, we need an AutoInc field in a table:
if file( "AutoIncTest.dbf" )
   drop table AutoIncTest
endif

// create a table:
create table AutoIncTest;
             ( MyKeyField AutoInc,;
               AName      character( 20 ) )
// add some data quickly:
use AutoIncTest
append blank
replace AName with "Test 1"
append blank
replace AName with "Test 2"
append blank
replace AName with "Test 3"
append blank
replace AName with "Test 4"
append blank
replace AName with "Test 5"
use
// we have five records, the AutoInc value should
// be 6 ...

// for the code to work it assumes we are using the
// standard dBL data classes:
qTest = new query()
qTest.sql    := "select * from AutoIncTest"
qTest.active := true
rTest = qTest.rowset

set procedure to :NonVisual:qBDEMgr.cc
// create an instance of the qBDEManager class:
oBDE = new qBDEManager()

// obtain the next value to be used by the AutoInc field:
? "Next AutoInc value: "+oBDE.GetAutoInc( rTest.handle )

// change it to some other value:
oBDE.SetAutoInc( rTest.handle, 10 )

// check to see:
? "Next AutoInc value: "+oBDE.GetAutoInc( rTest.handle )

// add a new row:
rTest.beginAppend()
rTest.fields["AName"].value := "Test 6"
rTest.save()
?
? "The New Row contains: "
? rTest.fields["MyKeyField"].value+" -- "+;
  rTest.fields["AName"].value


// cleanup
release object oBDE
oBDE := null

