/*
   Setup.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2012. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 25
   This is a program that can be used by a coder who wants to
   work on modifications to this application, and
   it can be called as a basic "setup" for the
   application from the Start program.

   It makes sure the environment that the developer
   is working in is okay, and any setup that might
   be done has been completed.

   Dependencies: Start.prg
                 mainmenu.mnu
*/
clear

// if we're not in the runtime environment,
// make sure the application's speedbar
// and statusbar are available:
if NOT "runtime" $ lower(version(1))
   _app.speedbar  := true
   _app.statusbar := true
endif


// ---------------------------------------------------------
// set procedures:
try
   set procedure to program(0)                additive
   set procedure to start                     additive
catch( exception E )
   msgbox( "Unexpected error occurred in program setup."+chr(13)+chr(13)+;
           "Error: "+e.code+" -- "+e.message+chr(13)+chr(13)+;
           "Program: "+e.filename+chr(13)+;
           "Line: "+e.lineno,;
           "Setup Error!", 16 )
endtry

// ---------------------------------------------------------
set epoch to 1950

// whatever else gets stuffed in here
set century on

return true

// end of main routine, we can store any functions here that we
// might want to use for multiple parts of the application ...:

/*
    End of SETUP.PRG
*/


