/*
   TestMorph.prg
   A sample dBL program from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2012. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 8 
   Show the basic concept of morphing a field that contains 
   1s and 0s to appear as a logical field ... this is useful 
   for datatabases that do not have logical or boolean 
   (or Yes/No) fields.
*/

// If table does not exist, run routine
// for this chapter that creates the tables ...
if not file("TestMorph.dbf")
   do MakeChapter8Tables
endif

// ---------------------------
// sample code from the book:
q = new query()
q.sql := "select * from TestMorph"
q.active := true
// create some shortcuts to the rowset and field array objects:
r = q.rowset
f = r.fields
r.first()
// show the value before morphing
? f["MyLogical"].value
// tell dBASE to morph the value to a logical:
f["MyLogical"].beforeGetValue := ;
        {; return iif( this.value==1, true, false ) }
// tell dBASE how to morph the value back to numeric:
f["MyLogical"].canChange := ;
        {|bValue|; this.value=iif(bValue, 1, 0); return false}
// show the value after morphing
? f["MyLogical"].value
// assign a new value
f["MyLogical"].value := false
// attempt to save it:
r.save()
// turn off the morphing so we can see the actual value:
f["MyLogical"].beforeGetValue := null
// show the actual value in the field:
? f["MyLogical"].value
// cleanup
q.active := false
release object q
