/*
   MyReportControls.cc
   A sample dBL custom class file from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2012. 
   Permission granted for use as a learning tool for dBASE Plus.

   Custom classes for use on reports
*/

class MainTitleText( parentObj ) of TEXT( parentObj ) custom
   with( this )
      height = 0.3438
      left = 2.3854
      top = 0.6521
      width = 2.7292
      metric = 3	// Inches
      prefixEnable = false
      alignHorizontal = 1	// Center
      fontSize = 20.0
      fontItalic = true
      text = "My Company Name"
   endwith
endclass

class SecondaryTitleText( parentObj ) of TEXT( parentObj ) custom
   with( this )
      height = 0.2605
      left = 2.3855
      top = 0.4063
      width = 2.7292
      metric = 3	// Inches
      prefixEnable = false
      alignHorizontal = 1	// Center
      fontSize = 16.0
      text = "Purpose of Report"
   endwith
endclass

class DATETEXT(parentObj) of TEXT(parentObj) custom
   with (this)
      height = 0.2083
      left = 2.8438
      top = 0.6563
      width = 1.8125
      metric = 3	// Inches
      prefixEnable = false
      alignHorizontal = 1	// Center
      fontSize = 12.0
      text = {||cmonth(date())+" "+day(date())+", "+year(date())}
   endwith
endclass

class DataText( parentObj ) of TEXT( parentObj ) custom
   with (this)
      fontName = "Arial"
      fontSize = 10.0
      text = "DataText"
   endwith

endclass

class DataHeadingText( parentObj ) of DataText( parentObj ) custom
   with( this )
      fontBold = true
      text = "DataHeadingText"
   endwith 
endclass

class DataColHeadingText( parentObj ) of DataHeadingText( parentObj ) custom
   with( this )
      text            = "ColumnHeadingText"
      suppressIfBlank = true
      canRender       = {|| this.parent.firstOnFrame }
   endwith
endclass
