/*
   GetReport.prg
   A sample dBL program from 
   The dBASE Reports Book
   by Kenneth J. Mayer. 
   Program copyright 2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 9
   This program will open the GetDates dialog form,
   and then based on what the user does, create a filter
   to be used with a report. The report will be displayed
   in the :dUFLP:Preview.wfm form.
*/

private oForm, dStart, dEnd, cFilter

// open the dialog:
set procedure to GetDates.wfm additive
oForm = new GetDatesForm()
if oForm.readModal()

   // when the user closes the form:
   dStart = oForm.dStart
   dEnd   = oForm.dEnd

   // create the filter string:
   cFilter = ""
   // if we have a start date:
   if not empty( dStart )
      cFilter := [Born => ']+dStart+[']
   endif
   // if we have an end date:
   if not empty( dEnd )
      // if we already have something in the filter:
      if not empty( cFilter )
         cFilter += [ and ]
      endif
      cFilter += [Born <= ']+dEnd+[']
   endif

   // create an associative array:
   aParams = new AssocArray()
   // add the filter to it:
   aParams["filter"] = cFilter

   // Next, we need to set up the Preview form:
   set procedure to :dUFLP:Preview.wfm additive
   oPreview = new PreviewForm()
   // set the params array:
   oPreview.params   = aParams
   // set the Modal property:
   oPreview.bModal   = true
   // set the report filename:
   oPreview.Viewer.fileName := "PreviewSample1.rep"

   // open it:
   oPreview.readModal()

   // cleanup -- once the Preview form closes:
   oPreview.release()
   close procedure :dUFLP:Preview.wfm

endif

// clean up memory:
oForm.release()
close procedure GetDates.wfm

