// See comments below regarding translations ...:
#include <custButtEnglish.h>    // completed
//#include <custButtItalian.h>    // completed
//#include <custButtGerman.h>     // completed
//#include <custButtDanish.h>     // completed
//#include <custButtNorwegian.h>  // completed
//#include <custButtFrench.h>     // completed
//#include <custButtCatalan.h>    // completed
//#include <custButtSpanish.h>    // completed
//#include <custButtPortuguese.h> // completed
//#include <custButtTurkish.h>    // completed

/*
   --------------------------------------------------------
   ToolBars.CC 
   Author...: Ken Mayer
   Date.....: May 25, 2000
   Notes....: Ken's Custom Button Class, reworked
              as "real" toolbars and "real" toolbuttons

   ***********************************************************
   ***********************************************************
   * IMPORTANT: these buttons require the use of a header 
   * file. This file defaults to English (custButtEnglish.h). 
   * However, if you are using another language other than 
   * English, you can change the speedTips and message dialog 
   * text for these simply by changing the header file in the
   * #include statement above to the appropriate file. 
   * Keep in mind that when you do this, you MUST recompile
   * ToolBars.cc (COMP ToolBars.cc in the command window ...)
   * or you will not see any changes ... 
   ***********************************************************
   * *** To use this properly, you may wish to copy
   * the header file or files you need to use to the
   * local directory, or better to the Visual dBASE\INCLUDE
   * directory ...
   ***********************************************************
   ***********************************************************

   UPDATED..: May 26, 2000
              Thanks to Gary White and Eric Bachleitner
              for testing ... and Gary for code ideas/changes
              to make it work from toolbars rather than containers
              on forms ...

              June 2, 2000 -- Gary did an overhaul on 
              the Vesper App which I use for testing
              a lot of things, and in the process, modified
              the toolbar code here ...

              August, 2004 -- Michael Nuwer and others 
              pointed out a problem with the code here,
              that may be a regression, but it's not
              really known. If the onUpdate code
              for the toolbar checks for atLast() or
              atFirst(), it acts as navigation, and
              if you are in beginEdit() or beginAppend()
              mode, you've just: 
                  a) had your changes saved due to implicit
                     saves;
                  b) been put back into browse mode if
                     the rowset's autoEdit is false.

   What we have:

   -----------------------------------------------------
   Toolbars
   You can use these 'as is' in a fashion similar to:
      set procedure to toolbars.cc additive
      tb = new kmToolBar1()
      tb.attach( formreference )
      tb.rowset = formreference.rowset // if needed
      // when form is closed:
      tb.detach( formreference )

      (to switch between forms, you could simply reattach ...?)

   If you don't want to use one of the first two, but
   wish to, perhaps, use two of the toolbars below,
   you could do:

      set procedure to toolbars.cc additive
      tb = new kmToolbarNavigate()
      tb2 = new kmToolBarEdit()
      tb.attach( formreference )
      tb.rowset = formreference.rowset // if needed
      tb2.attach( formreference )
      tb2.rowset = formreference.rowset 

      // when form is closed:
      tb.detach( formreference )
      tb2.detach( formreference )

   To attach to the main framework, you would use
     _app.framewin instead of "formreference" ...

   For more details, see the HowTo document in the 
   dBASE Knowledgebase on working with Toolbars.
   -----------------------------------------------------
   kmToolBar1 -- a toolbar with navigation, clipboard,
     editing (see kmToolBarEdit below) and a form close
     button ...

   kmToolBar2 -- a toolbar with navigation, clipboard,
     editing (see kmToolBarEdit2 below) and a form close
     button ...

   kmtoolbarNavigate -- A Toolbar which holds a set of
     navigation buttons. These use the current rowset
     of a form (this.parent.form.rowset), and do the 
     standard navigation through a table. 

   kmtoolbarEdit -- A Toolbar which holds a set of editing
     buttons. These are Append, Edit, Delete, Save, Cancel.

   kmtoolbarEdit2 -- Same as EditButtons, but next to the
     Append button is an instance of kmtbCarry

   kmtoolbarClipboard -- A Toolbar which holds the standard
     clipboard Cut, Copy, Paste buttons.

   kmtoolbarFind -- A Toolbar holding buttons (with no
     code) for Search, Search Again, and Replace

   ------------
   ToolButtons:
   ------------
   BaseToolButton -- this is what the other buttons
   are based on. If I need to change a shared property,
   I only have to change it here ... 

   // Many of the following use the 'split' images
   // in RESOURCE.DLL

   Navigation:
   kmtbTop      -- first row in rowset
   kmtbPrevious -- previous row ...
   kmtbNext     -- next ...
   kmtbEnd      -- last

   Editing:
   kmtbAdd      -- add new row
   kmtbEdit     -- edit current
   kmtbSave     -- save changes/new row
   kmtbDelete   -- delete row
   kmtbAbandon  -- abandon changes
   kmtbCarry    -- copies current record
                   to a new one, as if using
                   SET CARRY ON and/or SET CARRY TO
                   -- see notes in header for button
   Filter-by-Form:
   kmtbFilter   -- see docs below for this --
                       this is a busy button, but
                       very nicely coded ...
   Locate-by-Form:
   kmtbLocate   -- similar to above, but for locate ...

   ClipBoard:
   kmtbCut      -- as they sound
   kmtbCopy
   kmtbPaste

   Close form:
   kmtbClose    -- closes the current form

   ----------------------------------------------------------  
   The rest of these buttons have no code, you have
   to define it yourself, and to use these in a toolbar
   you have to create the toolbar, and add the toolbuttons
   to it ... -- i.e,
             t = new toolbar()
             t.floating = false
             t.flat = true
             // etc.
             t.yes   = new kmtbYes
             t.no    = new kmtbNew
             t.sep   = new kmtbSeparator
             t.close = new kmtbClose
               // etc.
             t.attach( formreference )
               // when done:
             t.detach( formreference )
   ----------------------------------------------------------     
   kmtbSeparator -- a separator 'button' used to display a 
                    a separator between buttons ...
   kmtbYes
   kmtbNo
   kmtbCancel
   kmtbQuestion
   kmtbLightning
   kmtbInfo
   kmtbFromDisk
   kmtbToDisk
   kmtbOpenFolder
   kmtbWrench
   kmtbPrint
   kmtbSearch
   kmtbSearchAgain
   kmtbReplace
   kmtbSearch2
   kmtbExit   // same as 'close', but no code ...
   kmtbFirstPage
   kmtbNextPage
   kmtbPreviousPage
   kmtbLightBulb


   DEPENDENCIES:
     A header file -- the default is:
       custbuttEnglish.h

     The idea here is that we can change the language
     simply by changing the header file. All strings that
     are displayed to a user are contained in the header
     file, including speedTips and text in dialog boxes.
     Translations are provided by those who speak English 
     and some other language -- I don't (not well enough 
     to translate -- I haven't spoken German since High 
     School and was not very good at it then).

     The #include statements are at the top of this file
     to make it easier to find ... if you need a language
     other than English, comment out the English header
     file and uncomment the one you need. If you need
     a language that isn't covered here, feel free to
     copy one of the translated files and translate
     to the language you need. However, please provide
     a copy to the library if you do so! Thanks.

     Other versions available (translators credited in
     the .H files):
        German
        French
        Italian
        Spanish
        Catalan
        Portuguese
        Danish
        Norwegian
        Turkish

      *** Note: To use these effectively, your best bet
      is to copy the appropriate header file(s) to the
      ..\Visual dBASE\INCLUDE directory ...
   ----------------------------------------------------------- 
*/

/* =======================================================
   We start with some Toolbars, which hold some of the 
   buttons defined later in this file
   ======================================================= */

/* --------------------------------------------------------
   kmToolBar1
   This has navigation, clipboard, and editing toolbuttons

   To use:

      tb = new kmToolBar1
      tb.attach( formreference )
         or
      tb.attach( _app.framewin )
      // set the rowset property:
      tbv.rowset := myform.rowset

      // when done:
      tb.detach( formreference )
         or
      tb.detach( _app.framewin )

    NOTE: two custom properties:
       rowset is the rowset this toolbar affects
       canFloat is logical: true allows it to float, if the
                            user drags it off the form, 
                            false means that if the user tries
                            when the onUpdate event fires
                            it will be returned to it's
                            previous position
   -------------------------------------------------------- */
class kmToolBar1 of Toolbar
   with (this)
      floating := false
   endwith
   this.rowset = null
   this.canFloat = false

   // Navigation buttons:
   this.kmtbTop1      = new kmtbTop(this)
   this.kmtbPrevious1 = new kmtbPrevious(this)
   this.kmtbNext1     = new kmtbNext(this)
   this.kmtbEnd1      = new kmtbEnd(this)

   // separator:
   this.kmtbSep1      = new kmtbSeparator(this)

   // Clipboard buttons:
   this.kmtbCut1      = new kmtbCut(this)
   this.kmtbCopy1     = new kmtbCopy(this)
   this.kmtbPaste1    = new kmtbPaste(this)

   // separator:
   this.kmtbSep2      = new kmtbSeparator(this)

   // Editbuttons:
   this.kmtbAdd1      = new kmtbAdd(this)
   this.kmtbEdit1     = new kmtbEdit(this)
   this.kmtbSave1     = new kmtbSave(this)
   this.kmtbAbandon1  = new kmtbAbandon(this)
   this.kmtbDelete1   = new kmtbDelete(this)

   function onUpdate // when toolbar updates
      if this.canFloat == false and this.floating
         this.floating := false
      endif

      if type("this.rowset") # "O";             // if we have no rowset
         and type("this.form.rowset") == "O"    // but the form does
         this.rowset := this.form.rowset        // use the form's rowset
      endif
      lRowset = type( "this.rowset" ) == "O"  // is there a rowset?
      // if we do have a rowset, check to see if we're at the
      // first/last records:
      if lRowset
         // Navigate buttons
         if this.rowset.state == 1 // Browse
            lAtFirst = this.rowset.atFirst()
            lAtLast  = this.rowset.atLast()
            this.kmtbTop1.enabled      := NOT lAtFirst
            this.kmtbPrevious1.enabled := NOT lAtFirst
            this.kmtbNext1.enabled     := NOT lAtLast
            this.kmtbEnd1.enabled      := NOT lAtLast
         endif
         // Edit buttons
         lEoF      = this.rowset.endOfSet
         lModified = this.rowset.modified
         this.kmtbAdd1.enabled      := true
         this.kmtbEdit1.enabled     := NOT lEoF
         this.kmtbSave1.enabled     := NOT lModified
         this.kmtbAbandon1.enabled  := NOT lModified
         this.kmtbDelete1.enabled   := NOT lEoF
      else
         // no rowset
         this.kmtbTop1.enabled      := false
         this.kmtbPrevious1.enabled := false
         this.kmtbNext1.enabled     := false
         this.kmtbEnd1.enabled      := false
         this.kmtbAdd1.enabled      := false
         this.kmtbEdit1.enabled     := false
         this.kmtbSave1.enabled     := false
         this.kmtbAbandon1.enabled  := false
         this.kmtbDelete1.enabled   := false
      endif

      // Clipboard buttons:
      lClip = ( TYPE("this.form.activeControl.copy") == "FP" )
      this.kmtbCut1.enabled   := lClip
      this.kmtbCopy1.enabled  := lClip
      this.kmtbPaste1.enabled := lClip

endclass

/* --------------------------------------------------------
   kmToolBar2
   This has navigation, clipboard, and editing (includes
   the 'carry' button) toolbuttons ...

   To use:

      tb = new kmToolBar2
      tb.attach( formreference )
         or
      tb.attach( _app.framewin )
      // set the rowset property:
      tbv.rowset := myform.rowset

      // when done:
      tb.detach( formreference )
         or
      tb.detach( _app.framewin )

    NOTE: two custom properties:
       rowset is the rowset this toolbar affects
       canFloat is logical: true allows it to float, if the
                            user drags it off the form, 
                            false means that if the user tries
                            when the onUpdate event fires
                            it will be returned to it's
                            previous position
   -------------------------------------------------------- */
class kmToolBar2 of Toolbar
   with (this)
      floating := false
   endwith
   this.rowset = null
   this.canFloat = false

   // Navigation buttons:
   this.kmtbTop1      = new kmtbTop(this)
   this.kmtbPrevious1 = new kmtbPrevious(this)
   this.kmtbNext1     = new kmtbNext(this)
   this.kmtbEnd1      = new kmtbEnd(this)

   // separator:
   this.kmtbSep1      = new kmtbSeparator(this)

   // Clipboard buttons:
   this.kmtbCut1      = new kmtbCut(this)
   this.kmtbCopy1     = new kmtbCopy(this)
   this.kmtbPaste1    = new kmtbPaste(this)

   // separator:
   this.kmtbSep2      = new kmtbSeparator(this)

   // Editbuttons:
   this.kmtbAdd1      = new kmtbAdd(this)
   this.kmtbCarry1    = new kmtbCarry(this)
   this.kmtbEdit1     = new kmtbEdit(this)
   this.kmtbSave1     = new kmtbSave(this)
   this.kmtbAbandon1  = new kmtbAbandon(this)
   this.kmtbDelete1   = new kmtbDelete(this)

   function onUpdate // when toolbar updates
      if this.canFloat == false and this.floating
         this.floating := false
      endif

      if type("this.rowset") # "O";             // if we have no rowset
         and type("this.form.rowset") == "O"    // but the form does
         this.rowset := this.form.rowset        // use the form's rowset
      endif
      lRowset = type( "this.rowset" ) == "O"  // is there a rowset?
      // if we do have a rowset, check to see if we're at the
      // first/last records:
      if lRowset
         // Navigate buttons
         if this.rowset.state == 1 // Browse
            lAtFirst = this.rowset.atFirst()
            lAtLast  = this.rowset.atLast()
            this.kmtbTop1.enabled      := NOT lAtFirst
            this.kmtbPrevious1.enabled := NOT lAtFirst
            this.kmtbNext1.enabled     := NOT lAtLast
            this.kmtbEnd1.enabled      := NOT lAtLast
         endif

         // Edit buttons
         lEoF      = this.rowset.endOfSet
         lModified = this.rowset.modified
         this.kmtbAdd1.enabled      := true
         this.kmtbCarry1.enabled    := true
         this.kmtbEdit1.enabled     := NOT lEoF
         this.kmtbSave1.enabled     := NOT lModified
         this.kmtbAbandon1.enabled  := NOT lModified
         this.kmtbDelete1.enabled   := NOT lEoF
      else
         // no rowset
         this.kmtbTop1.enabled      := false
         this.kmtbPrevious1.enabled := false
         this.kmtbNext1.enabled     := false
         this.kmtbEnd1.enabled      := false
         this.kmtbAdd1.enabled      := false
         this.kmtbCarry1.enabled    := false
         this.kmtbEdit1.enabled     := false
         this.kmtbSave1.enabled     := false
         this.kmtbAbandon1.enabled  := false
         this.kmtbDelete1.enabled   := false
      endif

      // Clipboard buttons:
      lClip = ( TYPE("this.form.activeControl.copy") == "FP" )
      this.kmtbCut1.enabled   := lClip
      this.kmtbCopy1.enabled  := lClip
      this.kmtbPaste1.enabled := lClip

endclass

/* --------------------------------------------------------
   Navigation Buttons Container
   Top, Previous, Next, End

   To use:

      tNav = new kmtoolbarNavigate
      tNav.attach( formreference )
         or
      tNav.attach( _app.framewin )
      // set the rowset property:
      tNav.rowset := myform.rowset

      // when done:
      tNav.detach( formreference )
         or
      tNav.detach( _app.framewin )

    NOTE: two custom properties:
       rowset is the rowset this toolbar affects
       canFloat is logical: true allows it to float, if the
                            user drags it off the form, 
                            false means that if the user tries
                            when the onUpdate event fires
                            it will be returned to it's
                            previous position
   -------------------------------------------------------- */
class kmtoolbarNavigate of Toolbar
   with (this)
      floating := false
   endwith
   this.rowset = null
   this.canFloat = false

   // The buttons:
   this.kmtbTop1 = new kmtbTop(this)
   this.kmtbPrevious1 = new kmtbPrevious(this)
   this.kmtbNext1 = new kmtbNext(this)
   this.kmtbEnd1 = new kmtbEnd(this)

   function onUpdate // when toolbar updates
      if this.canFloat == false and this.floating
         this.floating := false
      endif

      if type("this.rowset") # "O";             // if we have no rowset
         and type("this.form.rowset") == "O"    // but the form does
         this.rowset := this.form.rowset        // use the form's rowset
      endif
      lRowset = type( "this.rowset" ) == "O"  // is there a rowset?
      // if we do have a rowset, check to see if we're at the
      // first/last records:
      if lRowset
         if this.rowset.state == 1 // Browse
            lAtFirst = this.rowset.atFirst()
            lAtLast  = this.rowset.atLast()
            this.kmtbTop1.enabled      := NOT lAtFirst
            this.kmtbPrevious1.enabled := NOT lAtFirst
            this.kmtbNext1.enabled     := NOT lAtLast
            this.kmtbEnd1.enabled      := NOT lAtLast
         endif
      else
         // no rowset
         this.kmtbTop1.enabled      := false
         this.kmtbPrevious1.enabled := false
         this.kmtbNext1.enabled     := false
         this.kmtbEnd1.enabled      := false
      endif
endclass

/* --------------------------------------------------------
   Edit Buttons Container
   Add, Edit, Save, Abandon, Delete

   To use:

      tEdit = new kmtoolbarEdit
      tEdit.attach( formreference )
         or
      tEdit.attach( _app.framewin )
      // set the rowset property:
      tEdit.rowset := myform.rowset

      // when done:
      tEdit.detach( formreference )
         or
      tEdit.detach( _app.framewin )

    NOTE: two custom properties:
       rowset is the rowset this toolbar affects
       canFloat is logical: true allows it to float, if the
                            user drags it off the form, 
                            false means that if the user tries
                            when the onUpdate event fires
                            it will be returned to it's
                            previous position
   -------------------------------------------------------- */
class kmtoolbarEdit of Toolbar
   with (this)
      floating := false
   endwith
   this.rowset   = null
   this.canFloat = false

   // The buttons:
   this.kmtbAdd1 = new kmtbAdd(this)
   this.kmtbEdit1 = new kmtbEdit(this)
   this.kmtbSave1 = new kmtbSave(this)
   this.kmtbAbandon1 = new kmtbAbandon(this)
   this.kmtbDelete1 = new kmtbDelete(this)

   function onUpdate // when toolbar updates
      if this.canFloat == false and this.floating
         this.floating := false
      endif

      if type("this.rowset") # "O";             // if we have no rowset
         and type("this.form.rowset") == "O"    // but the form does
         this.rowset := this.form.rowset        // use the form's rowset
      endif
      lRowset = type( "this.rowset" ) == "O"  // is there a rowset?
      if lRowset
         lEoF      = this.rowset.endOfSet
         lModified = this.rowset.modified
         this.kmtbAdd1.enabled     := true
         this.kmtbEdit1.enabled    := NOT lEoF
         this.kmtbSave1.enabled    := NOT lModified
         this.kmtbAbandon1.enabled := NOT lModified
         this.kmtbDelete1.enabled  := NOT lEoF
      else
         this.kmtbAdd1.enabled     := false
         this.kmtbEdit1.enabled    := false
         this.kmtbSave1.enabled    := false
         this.kmtbAbandon1.enabled := false
         this.kmtbDelete1.enabled  := false
      endif

endclass

/* --------------------------------------------------------
   EditButtons2 -- has an instance of kmtbCarry
   Add, Carry, Edit, Save, Abandon, Delete

   To use:

      tEdit = new kmtoolbarEdit2
      tEdit.attach( formreference )
         or
      tEdit.attach( _app.framewin )
      // set the rowset property:
      tEdit.rowset := myform.rowset

      // when done:
      tEdit.detach( formreference )
         or
      tEdit.detach( _app.framewin )

    NOTE: two custom properties:
       rowset is the rowset this toolbar affects
       canFloat is logical: true allows it to float, if the
                            user drags it off the form, 
                            false means that if the user tries
                            when the onUpdate event fires
                            it will be returned to it's
                            previous position
   -------------------------------------------------------- */

class kmtoolbarEdit2 of Toolbar
   with (this)
      floating := false
   endwith
   this.rowset   = null
   this.canFloat = false

   // The buttons:
   this.kmtbAdd1 = new kmtbAdd(this)
   this.kmtbCarry1 = new kmtbCarry(this)
   this.kmtbEdit1 = new kmtbEdit(this)
   this.kmtbSave1 = new kmtbSave(this)
   this.kmtbAbandon1 = new kmtbAbandon(this)
   this.kmtbDelete1 = new kmtbDelete(this)

   function onUpdate // when toolbar updates
      if this.canFloat == false and this.floating
         this.floating := false
      endif

      if type("this.rowset") # "O";             // if we have no rowset
         and type("this.form.rowset") == "O"    // but the form does
         this.rowset := this.form.rowset        // use the form's rowset
      endif
      lRowset = type( "this.rowset" ) == "O"  // is there a rowset?

      if lRowset
         lEoF      = this.rowset.endOfSet
         lModified = this.rowset.modified
         this.kmtbAdd1.enabled     := true
         this.kmtbCarry1.enabled   := true
         this.kmtbEdit1.enabled    := NOT lEoF
         this.kmtbSave1.enabled    := NOT lModified
         this.kmtbAbandon1.enabled := NOT lModified
         this.kmtbDelete1.enabled  := NOT lEoF
      else
         this.kmtbAdd1.enabled     := false
         this.kmtbCarry1.enabled   := false
         this.kmtbEdit1.enabled    := false
         this.kmtbSave1.enabled    := false
         this.kmtbAbandon1.enabled := false
         this.kmtbDelete1.enabled  := false
      endif
endclass

/* --------------------------------------------------------
   Clipboard Buttons
   Cut, Copy, Paste

   To use:

      tClip = new kmtoolbarClipBoard
      tClip.attach( formreference )
         or
      tClip.attach( _app.framewin )
      // set the rowset property:
      tClip.rowset := myform.rowset

    NOTE: custom property:
       canFloat is logical: true allows it to float, if the
                            user drags it off the form, 
                            false means that if the user tries
                            when the onUpdate event fires
                            it will be returned to it's
                            previous position
   -------------------------------------------------------- */
class kmtoolbarClipBoard of Toolbar
   with (this)
      floating := true
   endwith
   this.canFloat = false

   // The buttons:
   this.kmtbCut1 = new kmtbCut(this)
   this.kmtbCopy1 = new kmtbCopy(this)
   this.kmtbPaste1 = new kmtbPaste(this)

   function onUpdate // when toolbar updates
      if this.canFloat == false and this.floating
         this.floating := false
      endif

      lClip = ( TYPE("this.form.activeControl.copy") == "FP" )
      this.kmtbCut1.enabled   := lClip
      this.kmtbCopy1.enabled  := lClip
      this.kmtbPaste1.enabled := lClip

endclass

/* --------------------------------------------------------
   Search Buttons
   Search, Replace, Search Again

   NOTE: These buttons have no code -- you would need
   to associate code with them. 

   You may want to use, instead, kmtbFilter or
   kmtbLocate ...

   To use:

      tFind = new kmtoolbarFind
      tFind.attach( formreference )
         or
      tFind.attach( _app.framewin )
      // set the rowset property:
      tFind.rowset := myform.rowset

      // when done:
      tFind.detach( formreference )
         or
      tFind.detach( _app.framewin )

    NOTE: two custom properties:
       rowset is the rowset this toolbar affects
       canFloat is logical: true allows it to float, if the
                            user drags it off the form, 
                            false means that if the user tries
                            when the onUpdate event fires
                            it will be returned to it's
                            previous position
   -------------------------------------------------------- */
class kmtoolbarFind of ToolBar
   with (this)
      floating := false
   endwith
   this.rowset   = null
   this.canFloat = false

   // The buttons:
   this.kmtbSearch1 = new kmtbSearch(this)
   this.kmtbReplace1 = new kmtbReplace(this)
   this.kmtbSearchAgain1 = new kmtbSearchAgain(this)

   function onUpdate // when toolbar updates
      if this.canFloat == false and this.floating
         this.floating := false
      endif

      if type("this.rowset") # "O";             // if we have no rowset
         and type("this.form.rowset") == "O"    // but the form does
         this.rowset := this.form.rowset        // use the form's rowset
      endif
      lRowset = type( "this.rowset" ) == "O"  // is there a rowset?
      this.kmtbSearch1.enabled      := lRowset
      this.kmtbReplace1.enabled     := lRowset
      this.kmtbSearchAgain1.enabled := lRowset
endclass

/* =======================================================
   Now for the Button definitions themselves:
   ======================================================= */

#DEFINE kmToolButtonWidth 17 // for standard "small" toolbutton
                             // images
#DEFINE kmBitMapWidth2    20 // for larger images, so they don't
                             // get cut off
/* =======================================================
   A Base Class: 
   ======================================================= */
class kmBaseToolButton( parentObj ) of ToolButton( parentObj ) custom
   this.twoState := false
   this.rowset   =  NULL // custom property!
   this.bitmapwidth := kmToolButtonWidth
endclass

/* =======================================================
   A separator button
   ======================================================= */
class kmtbSeparator( parentObj ) of ToolButton( parentObj ) custom
    this.separator   := true
    this.bitmapwidth := 2
endclass

/* =======================================================
   First, we start with the Navigation Buttons:
   ======================================================= */

/* ---------------------------------------------------- */
class kmtbTop( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.BitMap   := "RESOURCE:2 TS_FIRST"
   this.SpeedTip := TOPTIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( NAVNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to navigate ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6 // yes
                         rRowToActOn.save()
                      case nAnswer == 7 // no
                         rRowToActOn.abandon()
                      otherwise         // cancel
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTNAVIGATE, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTNAVIGATE, 16 )
                return
        endcase
        rRowToActOn.first()
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbPrevious( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.BitMap   := "RESOURCE:2 TS_PREV"
   this.SpeedTip := PREVTIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( NAVNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to navigate ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTNAVIGATE, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTNAVIGATE, 16 )
                return
        endcase
        if ( not rRowToActOn.next(-1) )
           rRowToActOn.next()
           msgbox( ATFIRSTROW, ;
                   CANTNAVIGATE, 64 )
        endif
     endif

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbNext( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.BitMap   := "RESOURCE:2 TS_NEXT"
   this.SpeedTip := NEXTTIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( NAVNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to navigate ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTNAVIGATE, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTNAVIGATE, 16 )
                return
        endcase
        if ( not rRowToActOn.next() )
           rRowToActOn.next(-1)
           msgbox( ATLASTROW, ;
                   CANTNAVIGATE, 64 )
        endif
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbEnd( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.BitMap   := "RESOURCE:2 TS_LAST"
   this.SpeedTip := ENDTIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( NAVNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to navigate ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTNAVIGATE, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTNAVIGATE, 16 )
                return
        endcase
        rRowToActOn.last()
     endif
endclass
/* ---------------------------------------------------- */

/* =======================================================
   Editing Buttons:
   ======================================================= */

/* ---------------------------------------------------- */
class kmtbAdd( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.BitMap   := "RESOURCE:2 TS_APPEND"
   this.SpeedTip := ADDTIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( ADDNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to add more rows ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTADDROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTADDROW, 16 )
                return
        endcase
        rRowToActOn.beginAppend()
     endif

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbCarry( parentObj ) of kmBaseToolButton( parentObj ) custom
/*    Notes.: This pushbutton will act like SET CARRY ON
            in the old XBase DML -- it will copy the contents
            of the current record, EXCEPT for any autoincrement,
            lock, or read-only fields.

            In addition, there is an optional property
            called "Carry" that can be used to specify a field
            list. It is suggested that you use the custom
            button's onOpen event (which does not currently 
            have any code assigned to it) to set this property 
            to list the fields you wish to copy when the user
            clicks the button. This would cause the button
            to act like the XBase DML: 
                SET CARRY TO <fieldname>,<fieldname>, etc.
            You would do it by using in the onOpen event
            of your instance of the button:
            	 this.carry = "<fieldname>,<fieldname>, etc."

            Warning: Fields that are not datalinked will also
            be copied unless you use the custom property 
            mentioned above ...

      11/02/1998 -- Jay C. Heil found a problem with
            _DBASELOCK fields, and also with lookupSQL
            fields. He threw some suggested changes at me
            which I have implemented, and after some more
            extensive testing, they seem to work fine.

*/
   with (this)
      Bitmap   := "RESOURCE #612"
      speedTip := CARRYTIP
   endwith

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( COPYNOROWSET,;
                CANTDOIT, 16 )
        return

     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to copy a row
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTCOPYROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTCOPYROW, 16 )
                return
        endcase

        // deal with field list (optional)
        if type( "this.Carry" ) == "C"
           lList = true
        else
           lList = false
        endif

        // array used to copy current record
        aCarry = new Array()
        // shorten the this.parent.form.rowset.fields references:
        fFields = rRowToActOn.fields

        // copy current record
        for i = 1 to fFields.size
            lAdd = true
            /*
               except for readonly, autoincrement or lock 
               (_dbaseLock) fields 
                NOTE: _dbaseLock fields don't have
                     type or readOnly properties,
                     so we have to make sure that they
                     exist before we check to see what
                     is in them ...
            */
            if ( type( "fFields[i].readOnly" ) # "U" and ;
                fFields[i].readOnly ) or ;
                  ( type ( "fFields[i].type" ) # "U" and ;
               "AUTOINC" $ fFields[i].type ) or ;
               fFields[i].className == "LOCKFIELD"
               lAdd = false
            endif

            // fields not in this.Carry if provided ...
            if lList AND ;
               NOT upper( fFields[i].fieldName ) $ ;
                   upper( this.Carry )
               lAdd = false
            endif

            if not lAdd
               aCarry.add( "* Skip This Field *" )
            else
               /*
                  if we have a lookupRowset, then
                  we have a lookupSQL statement, and
                  we need to ensure that we store the 
                  value that needs to be stored, NOT 
                  the value that will be returned by 
                  the lookupSQL ...
               */
               if fFields[i].lookupRowset # NULL
                  aCarry.add( fFields[i].lookupRowset.fields[2].value )
               else
                  aCarry.add( fFields[i].value )
               endif
            endif // this.parent.form.rowset.fields ...
        next

        // append a new record
        rRowToActOn.beginAppend()
            
        // -------------------------------
        // copy data from previous record:
        for i = 1 to fFields.size
            if aCarry[i] == "* Skip This Field *"
               loop
            else
               fFields[i].value := aCarry[i]
            endif  // skip ...
        next

        // redisplay
        rRowToActOn.refreshControls()

        // let user know:
        msgbox( ROWISCOPIED,;
                COPYCOMPLETE, 64 )
     endif
   return
endclass
/* ---------------------------------------------------- */
   
/* ---------------------------------------------------- */
class kmtbEdit( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap   := "RESOURCE:2 TS_EDIT"
   this.SpeedTip := EDITTIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( EDITNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to modify a row ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4 // filter
                msgbox( INFILTERMODE,;
                        CANTEDITROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTEDITROW, 16 )
                return
        endcase
        rRowToActOn.beginEdit()
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbSave( parentObj ) of kmBaseToolButton( parentObj ) custom
   this.Bitmap   := "RESOURCE:2 TS_SAVE"
   this.speedTip := SAVETIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( SAVENOROWSET,;
                CANTDOIT, 16 )
        return
     else
        nState = rRowToActOn.state
        do case
           case nState == 4
                msgbox( INFILTERMODE,;
                        CANTSAVEROW, 16 )
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTSAVEROW, 16 )
           case nState < 2 or nState > 3
                msgbox( NOTEDITING, NOCHANGES, 16 )
           otherwise
                // The following added by Tom Gleaton, avoids
                // problems when attempting to save a duplicate key:
                try
                   // Try it -- if no error is thrown, we're ok
                   rRowToActOn.save()
                catch (Exception E)
                   // oops -- abandon save, refresh the rowState object
                   rRowToActOn.abandon()
                   // deal with error returned:
                   if dbError() == "9729"
                      cError = KEYVIOLATION
                   else
                      cError = UNKNOWNERROR+dbError()
                   endif
                   // display it for user:
                   msgbox( cError, CANTSAVEROW, 16 )
                endtry
        endcase
        // for some reason, ONLY the save button
        // does not update the rowState ...
        this.parent.form.rowset.refreshControls()
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbDelete( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap   := "RESOURCE:2 TS_DELETE"
   this.SpeedTip := DELETETIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( DELETENOROWSET,;
                CANTDOIT, 16 )
        return
     else
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to delete a row
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4
                msgbox( INFILTERMODE,;
                        CANTDELETEROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTDELETEROW, 16 )
                return
        endcase
        // actually delete it
        if not rRowToActOn.endOfSet
           if ( msgbox(DELETEYESNO, ;
                       ALERT, 4) == 6 )
              rRowToActOn.delete()
              // move to previous row, unless we're at
              // the first one, and then step off
              // the endOfSet marker ...
              if ( not rRowToActOn.next(-1) )
                 rRowToActOn.next()
              endif
           endif
        else
           msgbox( NOTHINGTODELETE,EMPTYTABLE, 16 )
        endif
     endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbAbandon( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap   := "RESOURCE:2 TS_ABANDON"
   this.SpeedTip := ABANDONTIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( ABANDONNOROWSET,;
                CANTDOIT, 16 )
        return
     else
        nState = rRowToActOn.state
        do case
           case nState == 4
                if msgbox( ABANDONWILLCANCELFILTER,;
                           CANCELFILTER, 33 ) == 2
                   return
                endif
           case nState == 5 // locate
                if msgbox( ABANDONWILLCANCELLOCATE,;
                          CANCELLOCATE, 33 ) == 2
                   return
                endif
           case nState < 2 or nState > 3
                msgbox( NOTHINGTOABANDON, CANTABANDONROW, 16 )
                return
        endcase
        rRowToActOn.abandon()
     endif
endclass
/* ---------------------------------------------------- */

/*
   =====================================================
   FILTER and LOCATE buttons
   =====================================================
*/

/* ---------------------------------------------------- */
class kmtbFilter( parentObj ) of kmBaseToolButton( parentObj ) custom
/*
    Code by Santo Lo Galbo, in Italy
    This code was added 11/20/1998 -- it is designed
    to handle filter-by-form mode, and does it pretty
    durn well ...

    Minor modification added by Ronnie McGregor, 
      October, 20, 1999, to deal with the rowset's
      clearFilter() method possibly being called elsewhere
      in the form ... it adds an 'else' clause to
      the main IF xx.rowstate==4 ...
      * In addition, Ronnie's suggested image for the 
        clearFilter state of the button makes more sense
        than the one currently in use ... (suggested to
        use RESOURCE #2240, which is the eraser on a pencil,
        rather than RESOURCE #2020, which is a lightbulb)

    If the image is "Filter", then we save the current
    bookMark (in case we need it), and we set the form
    to a filter-by-form mode. (We change the button image
    to 'run')

    If the image is "Run", we call applyFilter. If no
    match is found we go back to the bookMark saved
    above (if possible -- otherwise we go to the first
    row in the table). This includes turning off the
    notifyControls while the filter kicks in and
    tries to find the row. We turn it back on and update
    the form. If we found a match, we set the button
    to "clearFilter". If we did not find a match, we
    set it back to 'filter'

    If the button image is "clearFilter" we issue
    a call to clearFilter() and reset the image back
    to filter.

    A right-click on the button will reset the
    rowset's state back to browse (abandoning 
    the filter) and the button's image ...

    Very smooth and nicely designed code, this is
    an *excellent* example of morphing an object ...

    Side effects: adds property to the form:
     form.bookMark

*/
   this.Bitmap         := "RESOURCE:2 TS_FILTER"
   this.SpeedTip       := FILTERTIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( FILTERNOROWSET,;
                CANTDOIT, 16 )
        return
     else
         // if so, check the rowset state -- if we
         // are editing/adding a row, we don't want 
         // allow navigation or filering or ...
         nState = rRowToActOn.state
         do case
            case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
            case nState == 5 // locate
                 msgbox( INLOCATEMODE,;
                         CANTSETFILTER, 16 )
                 return
         endcase

         do case
            // we are in "beginFilter" mode:
            case this.Bitmap == "RESOURCE:2 TS_FILTER"
                 // change bitmap to "Run"
                 this.Bitmap := "RESOURCE:2 TS_RUN"
                 // save current bookMark so we can return 
                 // to it:
                 this.parent.form.bookmark = rRowToActOn.bookMark()
                 // set form to "filter" mode
                 rRowToActOn.beginFilter()
            
            // we are in "Run" mode (applyFilter() )
            case this.Bitmap == "RESOURCE:2 TS_RUN"
                 // don't update the controls until told otherwise
                 rRowToActOn.notifyControls := false
                 // try the filter -- if we don't find a match
                 // we'll clear it out ...
                 try // catch error about memo:
                    // IF statement added by Ronnie MacGregor:
                    if rRowToActOn.state == 4 // Check that the rowset is in Filter mode
                       if not rRowToActOn.applyFilter()
                          // reset the image back to the filter image
                          this.Bitmap := "RESOURCE:2 TS_FILTER"
                          // clear the filter
                          rRowToActOn.clearFilter()
                          try
                             // attempt to go back to the 'bookMark'
                             // if we can't, we go to the first row
                             // in the table
                             rRowToActOn.goto( this.parent.form.bookmark )
                          catch ( exception e )
                             rRowToActOn.first()
                          endtry
                          // let the user know that no match was found
                          msgbox( NOMATCH, FILTER, 48 )
                       else
                          // otherwise the filter worked, 
                          // so now we want to change the image to
                          // a "clear Filter" ...
                          this.Bitmap := "RESOURCE #2240"
                       endif // not rRowToActOn.applyFilter()
                    // this is the rest of the code added by Ronnie MacGregor:
                    else 
                       // the clearFilter() method has been called,
                       // or the filter property has been cleared out ...
                       msgbox( CANTSETFILTER, CANTDOIT, 48 )
                       rRowToActOn.goto( this.parent.form.bookmark )
                       this.Bitmap := "RESOURCE:2 TS_FILTER"
                    endif // end of code added by RM
                 catch ( dbexception e )
                    msgbox( CANTFILTERINMEMO, FILTER, 48 )
                    rRowToActOn.goto( this.parent.form.bookmark )
                    this.Bitmap := "RESOURCE:2 TS_FILTER" 
                 endtry

                 // turn this back on
                 rRowToActOn.notifyControls := true
                 // and actually refresh to show the first row
                 // that matches the filter
                 rRowToActOn.refreshControls()
               
            // clearFilter()
            case this.Bitmap == "RESOURCE #2240"
                 // reset image to filter
                 this.Bitmap := "RESOURCE:2 TS_FILTER"
                 // clear out the current filter ...
                 rRowToActOn.clearFilter()
         endcase
      endif

   // this routine resets the button and
   // abandons the locate ...
   function onRightMouseDown // reset
     local rRowToActOn

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     if not this.Bitmap = "RESOURCE:2 TS_FILTER"
        rRowToActOn.abandon()
        rRowToActOn.clearFilter()
        this.Bitmap := "RESOURCE:2 TS_FILTER"
     endif

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbLocate( parentObj ) of kmBaseToolButton( parentObj ) custom
/*
    Santo Lo Galbo came through with some more code,
    this time to give a locate by form button.

    This one works similar to the kmFilterButton above,
    except that it does a locate-by-form.

    If the image is the TS_LOCATE image when the
    button is clicked, and we pass the checks
    to see what the rowset's state is, we
    change the image to TS_RUN, and then call
    the rowset's applyLocate -- this puts the form
    into locate-by-form mode.

    If the image is TS_RUN, we check to see if
    any changes were made in the form, and if not,
    we abandon the locate. Otherwise, we attempt
    to find something. If we can, we save the
    current bookmark, set the image to "locate again", 
    and let the user go for it again. 

    If the image is the "Locate again" image,
    we do another search unless we hit the endOfSet ...

    Very good example of morphing.

    Santo added an onRightMouseDown event call,
    which abandons (if necessary) and resets the
    image for the button ... rather handy to 
    simply reset this, and similar code has been
    copied above to the kmFilterButton as well.
    
    Side effects: adds property to the form:
     form.bookMark

*/
   this.Bitmap   := "RESOURCE:2 TS_LOCATE"
   this.SpeedTip := LOCATETIP

   function onClick
   /*
      Code below is by Santo Lo Galbo. This is similar to
      the kmFilterButton, except that it works with the
      locate-by-form abilities of the rowset ...
   */
     // first check to see if we're doing something
     // we shouldn't be when we attempt to set the filter:
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn == null
        msgbox( LOCATENOROWSET,;
                CANTDOIT, 16 )
        return
     else

        do case
           case rRowToActOn.state == 2 or ;
                rRowToActOn.state == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
                return
           case rRowToActOn.state == 4
                msgbox( EXITFROMFILTER, ;
                        CANTSEARCH, 16 )
                return
        endcase

        // here's where all the work starts:
        do case
           // we're now in "locate by form" mode:
           case this.Bitmap == "RESOURCE:2 TS_LOCATE"
                this.Bitmap := "RESOURCE:2 TS_RUN"
                this.parent.form.bookmark = rRowToActOn.bookmark()
                rRowToActOn.beginLocate()

           // we're in "Run" mode ...
           case this.Bitmap == "RESOURCE:2 TS_RUN"
                // if user hit 'run' but didn't
                // change anything on the form:
                if not rRowToActOn.modified
                   this.Bitmap := "RESOURCE:2 TS_LOCATE"
                   rRowToActOn.abandon()
                   return
                endif

                // problem with doing a locate on
                // memo fields:
                try // the first 'try'
                   // here's the search:
                   rRowToActOn.notifyControls := false
                   if not rRowToActOn.applyLocate()
                      this.Bitmap := "RESOURCE:2 TS_LOCATE"
                      try // second/nested try
                         rRowToActOn.goto( this.parent.form.bookmark )
                      catch ( exception e )
                         rRowToActOn.first()
                      endtry
                      msgbox( NOMATCH, SEARCH, 48 )
                   else
                      // we found a match ...
                      // search again image:
                      this.Bitmap := "RESOURCE #7030"
                      // save *this* bookmark ...
                      this.parent.form.bookmark = rRowToActOn.bookmark()
                   endif
                catch ( exception e )
                   msgbox( CANTSEARCHINMEMO, SEARCH, 48 )
                   rRowToActOn.goto( this.parent.form.bookmark )
                   this.Bitmap := "RESOURCE:2 TS_LOCATE"
                endtry // end of catch for memo

                rRowToActOn.notifyControls := true
                rRowToActOn.refreshControls()

           // we're "searching again"
           case this.Bitmap == "RESOURCE #7030"
                // look for the next match:
                if not rRowToActOn.locateNext()
                   rRowToActOn.goto( this.parent.form.bookmark )
                   msgbox( NOMOREMATCHES, SEARCH, 48 )
                   this.Bitmap := "RESOURCE:2 TS_LOCATE"
                else
                   this.parent.form.bookmark = rRowToActOn.bookmark()
                endif
        endcase

     endif

   // this routine resets the button and
   // abandons the locate ...
   function onRightMouseDown // reset
     local rRowToActOn

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     if not this.Bitmap = "RESOURCE:2 TS_LOCATE"
        rRowToActOn.abandon()
        this.Bitmap := "RESOURCE:2 TS_LOCATE"
     endif

endclass
/* ---------------------------------------------------- */

/* =======================================================
   Clipboard Buttons:
   ======================================================= */

/* ---------------------------------------------------- */
class kmtbCut( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_CUT"
   this.SpeedTip       := CUTTIP

   function onClick
       if type("this.form.activeControl.cut") == "FP"
          this.form.activeControl.cut()
       endif
endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbCopy( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_COPY"
   this.SpeedTip       := COPYTIP

   function onClick
       if type("this.form.activeControl.copy") == "FP"
          this.form.activeControl.copy()
       endif

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbPaste( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_PASTE"
   this.SpeedTip       := PASTETTIP

   function onClick
       if type("this.form.activeControl.paste") == "FP"
          this.form.activeControl.paste()
       endif

endclass
/* ---------------------------------------------------- */

/* =======================================================
   Misc. Buttons:
   ======================================================= */

/* ---------------------------------------------------- */
class kmtbClose( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #1005"
   this.SpeedTip       := CLOSETIP

   function onClick
     local rRowToActOn
     rRowToActOn = null

     // check to see if rowset property has been set:
     if this.rowset # null
        rRowToActOn = this.rowset
     // ok, this.rowset has not been set, check to see
     // if the parent has a rowset that's valid
     // (the parent will be "NavigateButtons", a container,
     // or the form):
     elseif this.parent.rowset # null
        rRowToActOn = this.parent.rowset
     // otherwise we check for the form's rowset:
     elseif this.parent.form.rowset # null
        rRowToActOn = this.parent.form.rowset
     endif

     // is there a valid rowset?
     if rRowToActOn # null
        // if so, check the rowset state -- if we
        // are editing/adding a row, we don't want 
        // to just close the form ...
        nState = rRowToActOn.state
        do case
           case nState == 2 or nState == 3
                if rRowToActOn.modified
                   nAnswer = msgbox(SAVECHANGES, ;
                                    DATACHANGED,32+3)
                   do case
                      case nAnswer == 6
                         rRowToActOn.save()
                      case nAnswer == 7
                         rRowToActOn.abandon()
                      otherwise
                         return
                   endcase
                endif
           case nState == 4
                msgbox( INFILTERMODE,;
                        CANTABANDONROW, 16 )
                return
           case nState == 5 // locate
                msgbox( INLOCATEMODE,;
                        CANTABANDONROW, 16 )
                return
        endcase
     endif
     if this.parent.form # null
        this.parent.form.close()
     endif
endclass
/* ---------------------------------------------------- */


/* =======================================================
   Buttons with no onClick event set ... you will need to
   create the code in your form ... (and you may want to
   override the speedTip property, too ...)
   ======================================================= */

/* ---------------------------------------------------- */
class kmtbYes( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #36"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := YESTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbNo( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #24"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := NOTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbCancel( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #28"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := CANCELTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbQuestion( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #32"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := QUESTIONTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbLightning( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_RUN"
   this.SpeedTip       := RUNTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbInfo( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #112"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := INFOTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbFromDisk( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #1410"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := RESTOREFROMDISKTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbToDisk( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #1430"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := SAVETODISKTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbOpenFolder( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_OPEN"
   this.SpeedTip       := OPENFILETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbWrench( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #144"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := TOOLBUTTONTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbPrint( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_PRINT "
   this.SpeedTip       := PRINTTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbSearch( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #858"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := SEARCHTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbSearchAgain( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #860"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := SEARCHAGAINTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbReplace( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #859"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := REPLACETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbSearch2( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_LOCATE"
   this.SpeedTip       := SEARCHTIP

endclass
/* ---------------------------------------------------- */


/* ---------------------------------------------------- */
class kmtbExit( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #1005"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := EXITTIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbFirstPage( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_RFIRST"
   this.SpeedTip       := FIRSTPAGETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbNextPage( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_RNEXT"
   this.SpeedTip       := NEXTPAGETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbPreviousPage( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE:2 TS_RPREV"
   this.SpeedTip       := PREVIOUSPAGETIP

endclass
/* ---------------------------------------------------- */

/* ---------------------------------------------------- */
class kmtbLightBulb( parentObj ) of kmBaseToolButton( parentObj ) custom

   this.Bitmap         := "RESOURCE #2020"
   this.bitMapWidth    := kmBitMapWidth2
   this.SpeedTip       := LIGHTBULBTIP

endclass
/* ---------------------------------------------------- */


/*
   =======================================================
   End of Custom Class file: TOOLBARS.CC
   ======================================================= 
*/

